/*
 * $Id: top_deallocation.cpp 113 2009-04-14 18:39:12Z rosiere $
 *
 * [ Description ]
 * 
 * Test
 */
#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/include/top.h"
#include "Behavioural/include/Allocation.h"

void top::deallocation (void)
{
#ifdef SYSTEMC
  delete             in_CLOCK;
  DELETE0_SC_SIGNAL( in_NRESET);

  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_VAL           );
  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_IN_ACK           );
  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_CONTEXT_ID    );
  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_FRONT_END_ID  );
  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_OOO_ENGINE_ID );
  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_PACKET_ID     );
//DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_OPERATION     );
//DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_TYPE          );
  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_FLAGS         );
  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_EXCEPTION     );
  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_NO_SEQUENCE   );
  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_ADDRESS       );
  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_IN_DATA          );

  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_VAL          );
  DELETE0_SC_SIGNAL( in_EXECUTE_QUEUE_OUT_ACK          );
  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_CONTEXT_ID   );
  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_FRONT_END_ID );
  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_OOO_ENGINE_ID);
  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_PACKET_ID    );
//DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_OPERATION    );
//DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_TYPE         );
  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_FLAGS        );
  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_EXCEPTION    );
  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_NO_SEQUENCE  );
  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_ADDRESS      );
  DELETE0_SC_SIGNAL(out_EXECUTE_QUEUE_OUT_DATA         );
#endif

  delete component;
#ifdef STATISTICS
  delete _param_stat;
#endif
}
